import { FormSOP } from '../../libappsop/formsop';
import { ListSOP } from '../../libappsop/listsop';
import { DialogSupplyCost } from '../dialogs/dialog.supplycost';

export class FormSupplyCost extends FormSOP {
  public listSupplyCost = new ListSupplyCost();
  public dialogSupplyCost = new DialogSupplyCost();

  public constructor() {
    super('FormSupplyCosts');
  }
}

export class ListSupplyCost extends ListSOP<DialogSupplyCost, ListSupplyCostColumn> {
  public static readonly title = 'Supply Costs';

  public constructor() {
    super('FormSupplyCosts.lsAccountCosts', new DialogSupplyCost());

    // Set primary key column name(s), to display in error message when assert fails
    this.rowPrimaryColumnNames = { Account: '', 'Cost driver': '', Date: '' };
  }
}

export interface ListSupplyCostColumn {
  Date?: string;
  Product?: string;
  'Stocking Point'?: string;
  Quantity?: string;
  UoM?: string;
  Description?: string;
  Account?: string;
  'Cost driver'?: string;
  Cost?: string;
  CurrencyUoM?: string;
}

const listSupplyCostContextMenuItem = {
  Edit: { ContextMenu: 'lsContextMenuAccCosts', Name: 'MenuEdit', Label: 'Edit' },
};

export { listSupplyCostContextMenuItem as ListSupplyCostContextMenuItem };
